<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>Kubernetes的yaml文件使用语法及简单操作 | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="apiVersion版本当编写一个yml文件时，第一行必须先写入apiVersion的版本不同的apiVersion可以实现不同的功能，或者配合不同的组件去使用官方文档也没有给出一个充分的解释使用kubectl api-version查看当前系统下的k8s支持的apiVersion有那些 1234567891011121314151617181920212223242526272829303132">
<meta property="og:type" content="article">
<meta property="og:title" content="Kubernetes的yaml文件使用语法及简单操作">
<meta property="og:url" content="http://example.com/2021/02/20/Kubernetes%E7%9A%84yaml%E6%96%87%E4%BB%B6%E4%BD%BF%E7%94%A8%E8%AF%AD%E6%B3%95%E5%8F%8A%E7%AE%80%E5%8D%95%E6%93%8D%E4%BD%9C/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="apiVersion版本当编写一个yml文件时，第一行必须先写入apiVersion的版本不同的apiVersion可以实现不同的功能，或者配合不同的组件去使用官方文档也没有给出一个充分的解释使用kubectl api-version查看当前系统下的k8s支持的apiVersion有那些 1234567891011121314151617181920212223242526272829303132">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2021-02-20T05:36:00.000Z">
<meta property="article:modified_time" content="2021-02-20T05:49:04.000Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2021/02/20/Kubernetes%E7%9A%84yaml%E6%96%87%E4%BB%B6%E4%BD%BF%E7%94%A8%E8%AF%AD%E6%B3%95%E5%8F%8A%E7%AE%80%E5%8D%95%E6%93%8D%E4%BD%9C/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: true,
  postUpdate: '2021-02-20 13:49:04'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">Kubernetes的yaml文件使用语法及简单操作</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2021-02-20T05:36:00.000Z" title="发表于 2021-02-20 13:36:00">2021-02-20</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2021-02-20T05:49:04.000Z" title="更新于 2021-02-20 13:49:04">2021-02-20</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/Kubernetes/">Kubernetes</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><h2 id="apiVersion版本"><a href="#apiVersion版本" class="headerlink" title="apiVersion版本"></a>apiVersion版本</h2><p>当编写一个yml文件时，第一行必须先写入apiVersion的版本<br>不同的apiVersion可以实现不同的功能，或者配合不同的组件去使用<br>官方文档也没有给出一个充分的解释<br>使用kubectl api-version查看当前系统下的k8s支持的apiVersion有那些</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br><span class="line">35</span><br></pre></td><td class="code"><pre><span class="line">[root@node1 ~]# kubectl api-versions </span><br><span class="line">admissionregistration.k8s.io&#x2F;v1</span><br><span class="line">admissionregistration.k8s.io&#x2F;v1beta1</span><br><span class="line">apiextensions.k8s.io&#x2F;v1</span><br><span class="line">apiextensions.k8s.io&#x2F;v1beta1</span><br><span class="line">apiregistration.k8s.io&#x2F;v1</span><br><span class="line">apiregistration.k8s.io&#x2F;v1beta1</span><br><span class="line">apps&#x2F;v1  # Deployment&#x2F;DaemonSet&#x2F;ReplicaSet</span><br><span class="line">authentication.k8s.io&#x2F;v1</span><br><span class="line">authentication.k8s.io&#x2F;v1beta1</span><br><span class="line">authorization.k8s.io&#x2F;v1</span><br><span class="line">authorization.k8s.io&#x2F;v1beta1</span><br><span class="line">autoscaling&#x2F;v1</span><br><span class="line">autoscaling&#x2F;v2beta1</span><br><span class="line">autoscaling&#x2F;v2beta2</span><br><span class="line">batch&#x2F;v1  # Job</span><br><span class="line">batch&#x2F;v1beta1</span><br><span class="line">batch&#x2F;v2alpha2</span><br><span class="line">certificates.k8s.io&#x2F;v1beta1</span><br><span class="line">coordination.k8s.io&#x2F;v1</span><br><span class="line">coordination.k8s.io&#x2F;v1beta1</span><br><span class="line">discovery.k8s.io&#x2F;v1beta1</span><br><span class="line">events.k8s.io&#x2F;v1beta1</span><br><span class="line">extensions&#x2F;v1beta1</span><br><span class="line">networking.k8s.io&#x2F;v1</span><br><span class="line">networking.k8s.io&#x2F;v1beta1</span><br><span class="line">node.k8s.io&#x2F;v1beta1</span><br><span class="line">policy&#x2F;v1beta1</span><br><span class="line">rbac.authorization.k8s.io&#x2F;v1</span><br><span class="line">rbac.authorization.k8s.io&#x2F;v1beta1</span><br><span class="line">scheduling.k8s.io&#x2F;v1</span><br><span class="line">scheduling.k8s.io&#x2F;v1beta1</span><br><span class="line">storage.k8s.io&#x2F;v1</span><br><span class="line">storage.k8s.io&#x2F;v1beta1</span><br><span class="line">v1   # service&#x2F;PersistentVolume&#x2F;Pod&#x2F;Secret&#x2F;ConfigMap</span><br></pre></td></tr></table></figure>
<h2 id="apiVersion版本分类"><a href="#apiVersion版本分类" class="headerlink" title="apiVersion版本分类"></a>apiVersion版本分类</h2><h3 id="alpha"><a href="#alpha" class="headerlink" title="alpha"></a>alpha</h3><p>apiVersion版本名称中包含alpha的，这是k8s准备出的一些新功能会包含在这个版本中，很有可能会出现未知无法解决的错误，仅用于测试的版本。测试没有问题，很有可能会纳入之后的新版本中。<br>不建议使用</p>
<h3 id="beta"><a href="#beta" class="headerlink" title="beta"></a>beta</h3><p>名称中包含beta的是基于alpha测试成功，被默认启用，会保留在后续版本中</p>
<h3 id="stable"><a href="#stable" class="headerlink" title="stable"></a>stable</h3><p>这是一个稳定版本，命名方式为v1/v2诸如类似，可以放心使用</p>
<h2 id="个别版本介绍"><a href="#个别版本介绍" class="headerlink" title="个别版本介绍"></a>个别版本介绍</h2><h3 id="v1"><a href="#v1" class="headerlink" title="v1"></a>v1</h3><p>Kubernetes API的稳定版本，包含了多核心对象Pod、service</p>
<h3 id="apps-v1beta2"><a href="#apps-v1beta2" class="headerlink" title="apps/v1beta2"></a>apps/v1beta2</h3><p>在kubernetes1.8版本中，新增加了apps/v1beta2的概念，apps/v1beta1同理<br>DaemonSet，Deployment，ReplicaSet 和 StatefulSet的当时版本迁入apps/v1beta2，兼容原有的extensions/v1beta1</p>
<h3 id="apps-v1"><a href="#apps-v1" class="headerlink" title="apps/v1"></a>apps/v1</h3><p>在kubernetes1.9版本中，引入apps/v1，deployment等资源从extensions/v1beta1, apps/v1beta1 和 apps/v1beta2迁入apps/v1，原来的v1beta1等被废弃。</p>
<p>apps/v1代表：包含一些通用的应用层的api组合，如：Deployments, RollingUpdates, 和ReplicaSets</p>
<h3 id="batch-v1"><a href="#batch-v1" class="headerlink" title="batch/v1"></a>batch/v1</h3><p>代表job相关的api组合</p>
<p>在kubernetes1.8版本中，新增了batch/v1beta1，后CronJob 已经迁移到了 batch/v1beta1，然后再迁入batch/v1</p>
<h3 id="autoscaling-v1"><a href="#autoscaling-v1" class="headerlink" title="autoscaling/v1"></a>autoscaling/v1</h3><p>代表自动扩缩容的api组合，kubernetes1.8版本中引入。<br>这个组合中后续的alpha 和 beta版本将支持基于memory使用量、其他监控指标进行扩缩容</p>
<h3 id="extensions-v1beta1"><a href="#extensions-v1beta1" class="headerlink" title="extensions/v1beta1"></a>extensions/v1beta1</h3><p>deployment等资源在1.6版本时放在这个版本中，后迁入到apps/v1beta2,再到apps/v1中统一管理</p>
<h3 id="certificates-k8s-io-v1beta1"><a href="#certificates-k8s-io-v1beta1" class="headerlink" title="certificates.k8s.io/v1beta1"></a>certificates.k8s.io/v1beta1</h3><p>安全认证相关的api组合</p>
<h3 id="authentication-k8s-io-v1"><a href="#authentication-k8s-io-v1" class="headerlink" title="authentication.k8s.io/v1"></a>authentication.k8s.io/v1</h3><p>资源鉴权相关的api组合</p>
<h2 id="k8s的yaml文件语法"><a href="#k8s的yaml文件语法" class="headerlink" title="k8s的yaml文件语法"></a>k8s的yaml文件语法</h2><blockquote>
<p>·大小写敏感<br>·使用缩进表示层级关系<br>·缩进时不允许使用Tab键，只允许使用空格。<br>·缩进的空格数目不重要，只要相同层级的元素左侧对齐即可<br>·# 表示注释，从这个字符一直到行尾，都会被解析器忽略。</p>
</blockquote>
<p>创建nginx示例</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br></pre></td><td class="code"><pre><span class="line">[root@node1 ~]# vim nginx.yml </span><br><span class="line">apiVersion: apps&#x2F;v1</span><br><span class="line">kind: Deployment</span><br><span class="line">metadata:</span><br><span class="line">  name: nginx-deployment</span><br><span class="line">spec:</span><br><span class="line">  selector:</span><br><span class="line">    matchLabels:</span><br><span class="line">      app: nginx</span><br><span class="line">  replicas: 2</span><br><span class="line">  template:</span><br><span class="line">    metadata:</span><br><span class="line">      labels:</span><br><span class="line">        app: nginx</span><br><span class="line">    spec:</span><br><span class="line">      containers:</span><br><span class="line">      - name: nginx</span><br><span class="line">        image: nginx:1.7.9</span><br><span class="line">        ports:</span><br><span class="line">        - containerPort: 80</span><br><span class="line">        volumeMounts:  # 数据映射</span><br><span class="line">        - name: html</span><br><span class="line">          mountPath: &#x2F;usr&#x2F;local&#x2F;apache2&#x2F;htdocs  # 所映射容器中的路径</span><br><span class="line">      volumes:</span><br><span class="line">      - name: html</span><br><span class="line">        hostPath:</span><br><span class="line">          path: &#x2F;zx   # 映射到物理机中的路径</span><br></pre></td></tr></table></figure>
<h3 id="yaml文件的固定结构"><a href="#yaml文件的固定结构" class="headerlink" title="yaml文件的固定结构"></a>yaml文件的固定结构</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br></pre></td><td class="code"><pre><span class="line">每个文件必须的结构如下：</span><br><span class="line">apiVersion: apps&#x2F;v1  # api版本</span><br><span class="line">kind: xxxx   # 要创建的资源类型，如Deployment&#x2F;Pod&#x2F;ReplicaSet&#x2F;StatefulSet&#x2F;DaemonSet&#x2F;Job&#x2F;Cronjob&#x2F;Service&#x2F;Ingress...</span><br><span class="line">metadata:    # 元数据对象，该资源的基本属性和信息</span><br><span class="line">  name: xxx  # 定义该资源的名称</span><br><span class="line">  namespace: xxx  # 命名空间，默认放到default空间</span><br><span class="line">  lables:    # 标签，在下一行定义键值对，可以是多对键值对</span><br><span class="line">    xxx: xxxx</span><br><span class="line">    xxx: xxxx</span><br><span class="line">  annotations # 资源注解</span><br><span class="line">    xxx: xxxx</span><br><span class="line">spec:   # 定义期望状态，详细的创建信息</span><br><span class="line">  containers:  # 容器列表</span><br><span class="line">  - name: xxx   # 容器名</span><br><span class="line">    image: xxxx  # 容器镜像</span><br><span class="line">status: # 当前状态，由k8s集群维护，不可以自定义</span><br></pre></td></tr></table></figure>
<h3 id="文件结构"><a href="#文件结构" class="headerlink" title="文件结构"></a>文件结构</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br><span class="line">35</span><br><span class="line">36</span><br><span class="line">37</span><br><span class="line">38</span><br><span class="line">39</span><br><span class="line">40</span><br><span class="line">41</span><br><span class="line">42</span><br><span class="line">43</span><br><span class="line">44</span><br><span class="line">45</span><br><span class="line">46</span><br><span class="line">47</span><br><span class="line">48</span><br><span class="line">49</span><br><span class="line">50</span><br><span class="line">51</span><br><span class="line">52</span><br><span class="line">53</span><br><span class="line">54</span><br><span class="line">55</span><br><span class="line">56</span><br><span class="line">57</span><br><span class="line">58</span><br><span class="line">59</span><br><span class="line">60</span><br><span class="line">61</span><br><span class="line">62</span><br><span class="line">63</span><br><span class="line">64</span><br><span class="line">65</span><br><span class="line">66</span><br><span class="line">67</span><br><span class="line">68</span><br><span class="line">69</span><br><span class="line">70</span><br><span class="line">71</span><br><span class="line">72</span><br><span class="line">73</span><br><span class="line">74</span><br><span class="line">75</span><br><span class="line">76</span><br><span class="line">77</span><br><span class="line">78</span><br><span class="line">79</span><br><span class="line">80</span><br><span class="line">81</span><br><span class="line">82</span><br><span class="line">83</span><br><span class="line">84</span><br><span class="line">85</span><br><span class="line">86</span><br><span class="line">87</span><br><span class="line">88</span><br><span class="line">89</span><br></pre></td><td class="code"><pre><span class="line"># Controller定义部分</span><br><span class="line">------------------------------------------</span><br><span class="line">apiVersion: apps&#x2F;v1   # api版本(必须的)</span><br><span class="line">kind: Deployment   # 表示要创建的Controller资源类型</span><br><span class="line">metadata:   # 元数据对象，该资源的基本属性和信息(必须的)</span><br><span class="line">  name: nginx-deployment  # 定义该资源的名称（必须的），同一命名空间内，必须唯一</span><br><span class="line">  namespace: xxxx  # 命名空间，默认放到default空间（可选）</span><br><span class="line">  labels:  # 标签，用来定位一个或多个资源，键值对方式进行定义，下方使用的selector会与这里的键值对对应，作为selector的挑选条件</span><br><span class="line">    app: nginx  # 设置key为app，value为nginx</span><br><span class="line">------------------------------------------</span><br><span class="line"># 资源的特点</span><br><span class="line">------------------------------------------</span><br><span class="line">spec:  # 描述该资源的创建信息，对应kind资源类型的信息</span><br><span class="line">  revisionHistoryLimit: 10  # 回滚时会用到，用来保留最近10的版本</span><br><span class="line">  replicas: 2  # 创建2个应用实例</span><br><span class="line">  selector:  </span><br><span class="line">  # 标签选择器，与上面的标签共用，这个部分是17版本开始加的，必须与上面的labels对应</span><br><span class="line">    matchLabels: # 选择包含标签app:nginx的资源</span><br><span class="line">    # 正确的Deployment,让matchLabels 和template.metadata.lables完全匹配才能不报错</span><br><span class="line">    # 直接不写spec.mathlabels创建直接报错缺少缺少必要字段selector</span><br><span class="line">    # 当把matchLables匹配的和下面pod模板不相对应,也会直接报错：选择的标签和模板标签不匹配</span><br><span class="line">    # matchLabel是pod的标签选择器。 由此选择其pod的现有ReplicaSet(副本集)将受此部署影响的副本。</span><br><span class="line">      app: nginx</span><br><span class="line">------------------------------------------</span><br><span class="line"># Pod的模板</span><br><span class="line">------------------------------------------</span><br><span class="line">  template:  # 选择或创建的Pod模板</span><br><span class="line">    metadata: # Pod的元数据，Pod的信息</span><br><span class="line">      labels: # Pod标签</span><br><span class="line">        app: nginx</span><br><span class="line">------------------------------------------</span><br><span class="line">Container的模板</span><br><span class="line">------------------------------------------</span><br><span class="line">    spec:  # 期望Pod实现的功能（在Pod中部署什么）</span><br><span class="line">      strategy:  # 在滚动更新Pod时的启动Pod数量比值</span><br><span class="line">        rollingUpdate:</span><br><span class="line">          maxSurge: 35%</span><br><span class="line">          maxUnavailable: 35%</span><br><span class="line">      nodeSelector:  # 指定pod运行在哪个集群节点</span><br><span class="line">      restartPolicy: # 容器重启策略(Never&#x2F;Always&#x2F;OnFailure)</span><br><span class="line">      hostNetwork: true  # 表示直接使用节点中的主机网络，相当于docker的host网络</span><br><span class="line">      containers:   # 在Pod中生成容器，容器列表，可写入多个镜像的实例</span><br><span class="line">      - name: xxxx   # 定义容器名</span><br><span class="line">        image: xxxx  # 容器使用的镜像</span><br><span class="line">      - name: xxxx</span><br><span class="line">        image: xxxx</span><br><span class="line">        imagePullPolicy:  </span><br><span class="line">        # 镜像下载策略（IfNotPresent&#x2F;Never&#x2F;Always）</span><br><span class="line">        # 分别代表，没有镜像时下载，从不下载，总是下载</span><br><span class="line">        command: # 运行程序&#x3D;&#x3D;dockerfile中的ENTRYPOINT，或者docker run时最后跟的&#x2F;bin&#x2F;bash等命令，会替代dockerfile中cmd和ENTRYPOINT执行的命令</span><br><span class="line">        - echo</span><br><span class="line">        - &#39;hello world&#39;</span><br><span class="line">        args: # 向docker镜像中传递命令，通常用来给command传参，也可以单独使用，与dockerfile中的CMD作用一样，如果yml中只写了args，将会给dockerfile中的ENTRYPOINT传参，dockerfile中的CMD会失效。</span><br><span class="line">        - xxx</span><br><span class="line">        - xxx </span><br><span class="line">        ports:  # 用来暴露端口，并不是端口映射，仅仅为了可以看到容器中使用了哪两个端口</span><br><span class="line">        - name: xxx</span><br><span class="line">          containerPort: 80  # 容器中提供服务的端口</span><br><span class="line">          protocol: TCP&#x2F;UDP # 默认是tcp</span><br><span class="line">        - name: xxx</span><br><span class="line">          containerPort: 443</span><br><span class="line">        volumeMounts: # 用来指定容器内的路径</span><br><span class="line">        - name: nginxconf</span><br><span class="line">          mountPath: &#x2F;usr&#x2F;local&#x2F;nginx&#x2F;conf</span><br><span class="line">        - name: nginxhtml</span><br><span class="line">          mountPath: &#x2F;usr&#x2F;local&#x2F;nginx&#x2F;html</span><br><span class="line">          readOnly: True  # 设置容器内只读，默认是读写</span><br><span class="line">      volumes:   # 指定对应name的物理机路径,缩进与上方的containers对齐</span><br><span class="line">      - name: nginxconf</span><br><span class="line">        hostPath: </span><br><span class="line">          path: &#x2F;nginx&#x2F;conf</span><br><span class="line">      - name: nginxhtml</span><br><span class="line">        hostPath: </span><br><span class="line">          path: &#x2F;nginx&#x2F;html</span><br><span class="line">      - name: xxx</span><br><span class="line">        emptyDir: &#123;&#125;</span><br><span class="line">      - name: xxx   </span><br><span class="line">        persistentVolumeClaim:   # 使用PVC存储资源</span><br><span class="line">          claimName: xxxxx-xxx</span><br><span class="line">        LivenessProbe:   # 存活检测，判断文件是否存在，检测失败重启容器</span><br><span class="line">          exec:</span><br><span class="line">            command:</span><br><span class="line">              - cat</span><br><span class="line">              - &#x2F;tmp&#x2F;healthy</span><br><span class="line">        readinessProbe:  # 读取检测，判断文件是否存在，检测失败，标记为不可用，将不会被Service所负载</span><br><span class="line">          exec:</span><br><span class="line">            command:</span><br><span class="line">              - cat</span><br><span class="line">              - &#x2F;tmp&#x2F;healthy</span><br></pre></td></tr></table></figure>
<h3 id="Labels的重要性"><a href="#Labels的重要性" class="headerlink" title="Labels的重要性"></a>Labels的重要性</h3><p>在新版的k8s中labels是非常重要的</p>
<blockquote>
<p>注意： 必须在 Deployment 中指定适当的选择器和 Pod 模板标签（在本例中为app: nginx）。不要与其他控制器（包括其他 Deployments 和状态设置）重叠标签或选择器。Kubernetes 不会阻止重叠，如果多个控制器具有重叠的选择器，这些控制器可能会冲突并运行意外。</p>
</blockquote>
<h3 id="matchLabels-matchExpression作用"><a href="#matchLabels-matchExpression作用" class="headerlink" title="matchLabels/matchExpression作用"></a>matchLabels/matchExpression作用</h3><blockquote>
<p>matchLabels用于定义一组Label，与直接写在Selector中作用相同，直接给定键值； matchExpression用于定义一组基于集合的筛选条件，基于表达式来定义使用标签选择器，{key: KEY}</p>
</blockquote>
<h3 id="matchLabels使用场景"><a href="#matchLabels使用场景" class="headerlink" title="matchLabels使用场景"></a>matchLabels使用场景</h3><p>1.kube-controller进程通过资源对象ReplicaSet上定义的Label Selector来筛选要监控的Pod副本的数量，从而实现Pod副本的数量始终符合预期设定的全自动控制流程</p>
<p>2.kube-proxy进程通过Service的Label Selector来选择对应的Pod，自动建立器每个Service到对应Pod的请求转发路由表，从而实现Service的智能负载均衡机制</p>
<p>3.通过对某些Node定义特定的Label,并且在Pod定义文件中使用NodeSelector这种标签调度策略，Kube-scheduler进程可以实现Pod定向调度的特性</p>
<h3 id="Pod-选择器"><a href="#Pod-选择器" class="headerlink" title="Pod 选择器"></a>Pod 选择器</h3><p>.spec.selector 字段是一个标签选择器。 ReplicationController 管理标签与选择器匹配的所有 Pod。 它不区分它创建或删除的 Pod 和其他人或进程创建或删除的 Pod。 这允许在不影响正在运行的 Pod 的情况下替换 ReplicationController。</p>
<p>如果指定了 .spec.template.metadata.labels，它必须和 .spec.selector 相同，否则它将被 API 拒绝。 如果没有指定 .spec.selector，它将默认为 .spec.template.metadata.labels。</p>
<p>另外，通常不应直接使用另一个 ReplicationController 或另一个控制器（例如 Job）来创建其标签与该选择器匹配的任何 Pod。如果这样做，ReplicationController 会认为它创建了这些 Pod，就会产生冲突， Kubernetes 并没有阻止你这样做。</p>
<h2 id="使用Deloyment部署httpd"><a href="#使用Deloyment部署httpd" class="headerlink" title="使用Deloyment部署httpd"></a>使用Deloyment部署httpd</h2><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br></pre></td><td class="code"><pre><span class="line">[root@node1 ~]# vim httpd.yml</span><br><span class="line">apiVersion: apps&#x2F;v1</span><br><span class="line">kind: Deployment</span><br><span class="line">metadata:</span><br><span class="line">  name: httpd-deployment</span><br><span class="line">spec:</span><br><span class="line">  replicas: 3</span><br><span class="line">  selector:</span><br><span class="line">    matchLabels:</span><br><span class="line">      run: httpd</span><br><span class="line">  template:</span><br><span class="line">    metadata:</span><br><span class="line">      labels:</span><br><span class="line">        run: httpd</span><br><span class="line">    spec:</span><br><span class="line">      containers:</span><br><span class="line">      - name: httpd</span><br><span class="line">        image: httpd:latest</span><br><span class="line">        ports:</span><br><span class="line">        - containerPort: 80</span><br></pre></td></tr></table></figure>
<h3 id="运行httpd-deployment"><a href="#运行httpd-deployment" class="headerlink" title="运行httpd-deployment"></a>运行httpd-deployment</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">[root@node1 ~]# kubectl apply -f httpd.yml </span><br><span class="line">deployment.apps&#x2F;httpd-deployment created</span><br></pre></td></tr></table></figure>
<h3 id="查看Pod"><a href="#查看Pod" class="headerlink" title="查看Pod"></a>查看Pod</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">[root@node1 ~]# kubectl get pod</span><br><span class="line">NAME                                READY   STATUS    RESTARTS   AGE</span><br><span class="line">httpd-deployment-5dd67c6b75-mdnsz   1&#x2F;1     Running   0          77s</span><br><span class="line">httpd-deployment-5dd67c6b75-v2pmt   1&#x2F;1     Running   0          77s</span><br><span class="line">httpd-deployment-5dd67c6b75-zfrgb   1&#x2F;1     Running   0          77s</span><br></pre></td></tr></table></figure>
<h3 id="想要查看某个Deployment中的pod，可以根据各自的标签来查看，如下："><a href="#想要查看某个Deployment中的pod，可以根据各自的标签来查看，如下：" class="headerlink" title="想要查看某个Deployment中的pod，可以根据各自的标签来查看，如下："></a>想要查看某个Deployment中的pod，可以根据各自的标签来查看，如下：</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br></pre></td><td class="code"><pre><span class="line">[root@node1 ~]# kubectl get pods -l run&#x3D;httpd</span><br><span class="line">NAME                                READY   STATUS    RESTARTS   AGE</span><br><span class="line">httpd-deployment-5dd67c6b75-mdnsz   1&#x2F;1     Running   0          2m29s</span><br><span class="line">httpd-deployment-5dd67c6b75-v2pmt   1&#x2F;1     Running   0          2m29s</span><br><span class="line">httpd-deployment-5dd67c6b75-zfrgb   1&#x2F;1     Running   0          2m29s</span><br><span class="line">[root@node1 ~]# kubectl get pods -l app&#x3D;nginx</span><br><span class="line">NAME                                READY   STATUS    RESTARTS   AGE</span><br><span class="line">nginx-deployment-5bf87f5f59-8rrjv   1&#x2F;1     Running   0          41m</span><br><span class="line">nginx-deployment-5bf87f5f59-cxjdm   1&#x2F;1     Running   0          41m</span><br></pre></td></tr></table></figure></article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2021/02/20/Kubernetes%E7%9A%84yaml%E6%96%87%E4%BB%B6%E4%BD%BF%E7%94%A8%E8%AF%AD%E6%B3%95%E5%8F%8A%E7%AE%80%E5%8D%95%E6%93%8D%E4%BD%9C/">http://example.com/2021/02/20/Kubernetes%E7%9A%84yaml%E6%96%87%E4%BB%B6%E4%BD%BF%E7%94%A8%E8%AF%AD%E6%B3%95%E5%8F%8A%E7%AE%80%E5%8D%95%E6%93%8D%E4%BD%9C/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2021/02/20/Kubernetes%E7%9A%84Deployment-Scale-Up-or-Down/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">Kubernetes的Deployment Scale Up or Down(伸缩)</div></div></a></div><div class="next-post pull-right"><a href="/2021/02/20/Kubernetes%E7%AE%80%E5%8D%95%E8%B5%84%E6%BA%90%E9%83%A8%E7%BD%B2/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">Kubernetes简单资源部署</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget" id="card-toc"><div class="item-headline"><i class="fas fa-stream"></i><span>目录</span></div><div class="toc-content"><ol class="toc"><li class="toc-item toc-level-2"><a class="toc-link" href="#apiVersion%E7%89%88%E6%9C%AC"><span class="toc-number">1.</span> <span class="toc-text">apiVersion版本</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#apiVersion%E7%89%88%E6%9C%AC%E5%88%86%E7%B1%BB"><span class="toc-number">2.</span> <span class="toc-text">apiVersion版本分类</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#alpha"><span class="toc-number">2.1.</span> <span class="toc-text">alpha</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#beta"><span class="toc-number">2.2.</span> <span class="toc-text">beta</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#stable"><span class="toc-number">2.3.</span> <span class="toc-text">stable</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E4%B8%AA%E5%88%AB%E7%89%88%E6%9C%AC%E4%BB%8B%E7%BB%8D"><span class="toc-number">3.</span> <span class="toc-text">个别版本介绍</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#v1"><span class="toc-number">3.1.</span> <span class="toc-text">v1</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#apps-v1beta2"><span class="toc-number">3.2.</span> <span class="toc-text">apps&#x2F;v1beta2</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#apps-v1"><span class="toc-number">3.3.</span> <span class="toc-text">apps&#x2F;v1</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#batch-v1"><span class="toc-number">3.4.</span> <span class="toc-text">batch&#x2F;v1</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#autoscaling-v1"><span class="toc-number">3.5.</span> <span class="toc-text">autoscaling&#x2F;v1</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#extensions-v1beta1"><span class="toc-number">3.6.</span> <span class="toc-text">extensions&#x2F;v1beta1</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#certificates-k8s-io-v1beta1"><span class="toc-number">3.7.</span> <span class="toc-text">certificates.k8s.io&#x2F;v1beta1</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#authentication-k8s-io-v1"><span class="toc-number">3.8.</span> <span class="toc-text">authentication.k8s.io&#x2F;v1</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#k8s%E7%9A%84yaml%E6%96%87%E4%BB%B6%E8%AF%AD%E6%B3%95"><span class="toc-number">4.</span> <span class="toc-text">k8s的yaml文件语法</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#yaml%E6%96%87%E4%BB%B6%E7%9A%84%E5%9B%BA%E5%AE%9A%E7%BB%93%E6%9E%84"><span class="toc-number">4.1.</span> <span class="toc-text">yaml文件的固定结构</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%96%87%E4%BB%B6%E7%BB%93%E6%9E%84"><span class="toc-number">4.2.</span> <span class="toc-text">文件结构</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Labels%E7%9A%84%E9%87%8D%E8%A6%81%E6%80%A7"><span class="toc-number">4.3.</span> <span class="toc-text">Labels的重要性</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#matchLabels-matchExpression%E4%BD%9C%E7%94%A8"><span class="toc-number">4.4.</span> <span class="toc-text">matchLabels&#x2F;matchExpression作用</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#matchLabels%E4%BD%BF%E7%94%A8%E5%9C%BA%E6%99%AF"><span class="toc-number">4.5.</span> <span class="toc-text">matchLabels使用场景</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Pod-%E9%80%89%E6%8B%A9%E5%99%A8"><span class="toc-number">4.6.</span> <span class="toc-text">Pod 选择器</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E4%BD%BF%E7%94%A8Deloyment%E9%83%A8%E7%BD%B2httpd"><span class="toc-number">5.</span> <span class="toc-text">使用Deloyment部署httpd</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E8%BF%90%E8%A1%8Chttpd-deployment"><span class="toc-number">5.1.</span> <span class="toc-text">运行httpd-deployment</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%9F%A5%E7%9C%8BPod"><span class="toc-number">5.2.</span> <span class="toc-text">查看Pod</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%83%B3%E8%A6%81%E6%9F%A5%E7%9C%8B%E6%9F%90%E4%B8%AADeployment%E4%B8%AD%E7%9A%84pod%EF%BC%8C%E5%8F%AF%E4%BB%A5%E6%A0%B9%E6%8D%AE%E5%90%84%E8%87%AA%E7%9A%84%E6%A0%87%E7%AD%BE%E6%9D%A5%E6%9F%A5%E7%9C%8B%EF%BC%8C%E5%A6%82%E4%B8%8B%EF%BC%9A"><span class="toc-number">5.3.</span> <span class="toc-text">想要查看某个Deployment中的pod，可以根据各自的标签来查看，如下：</span></a></li></ol></li></ol></div></div><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button class="close" id="mobile-toc-button" type="button" title="目录"><i class="fas fa-list-ul"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>